(* ::Package:: *)

(* AutoDipole - Package of an automated dipole subtraction by
Kouhei Hasegawa, Sven Moch, and Peter Uwer, 2009 *)


(* Filename:driver.m  :driver of the package *)


CreateAll[ilist_,flist_]:=Module[{},
Realprocess[ilist,flist];
VirtualCreation;
PDFfactorizationCreation;
printsummary;
];


(* Real part: Dipole tems creation *)
Realprocess[ilist_,flist_]:=Module[{},
Print["Dipole creation"];
<<dipole.m;
Dipole[ilist,flist];
<<dipolefortran.m;
Dipolefortran;
<<shellformad.m;
createcolor;
createamplitude;
createemitspecinfo;
createnexternal;
writecheck;
writecheckIR;
];


(* Virtual part: I-tem creation *)
VirtualCreation:=Module[{},
Print["Virtual creation"];
If[dAs >=1,
Virtualprocess[ilist_,flist_]:=Module[{},
<<virtual.m;
Itermcreation[ilist,flist];
<<virtualfortran.m;
Virtualfortran;];
Virtualprocess[{A[1],A[2]},A1];,
Print["No B1 exists"];
];
];


(* PDF factorization part: P and K-tems creation *)
PDFfactorizationCreation:=Module[{},
Print["PK creation"];
If[pkexist >= 1,
<<PDFfactorization.m;
PandKtermscreation;
<<PDFfactorizationfortran.m;
PandKtermsfortran;
,Print["No P and K term exists"];
];
];
